# $Id: iface.tcl,v 1.22 2002/11/02 20:42:04 alexey Exp $

set xselection ""

proc EncodeTextSelection {txt offset len} {
    set ::xselection [eval $txt get [$txt tag ranges sel]]
    encoding convertto \
	[crange $::xselection $offset [expr $offset + $len - 1]]
}

proc EncodeEntrySelection {txt offset len} {
    if [$txt selection present] {
	set idx1 [$txt index sel.first]	
	set idx2 [$txt index sel.last]
	set ::xselection [string range [$txt get] $idx1 $idx2]
	encoding convertto \
	    [crange $::xselection $offset [expr $offset + $len - 1]]
    } else {
	set ::xselection ""
    }
}

if {$tcl_platform(platform) == "unix"} {
    bind Text  <Map> { selection handle %W "EncodeTextSelection %W"}
    bind Entry <Map> { selection handle %W "EncodeEntrySelection %W"}
    #bind Text  <Unmap> { selection handle %W {}}
    #bind Entry <Unmap> { selection handle %W {}}

    bind Text <ButtonRelease-2> {
	if [catch {set sel [selection get]}] continue
	if {[selection own] == ""} {
	    set sel [encoding convertfrom $sel]
	} else {
	    set sel $xselection
	}
	%W insert current $sel
    }
    bind Entry <ButtonRelease-2> {
	if [catch {set sel [selection get]}] continue
	if {[selection own] == ""} {
	    set sel [encoding convertfrom $sel]
	} else {
	    set sel $xselection
	}
	%W insert insert $sel
    }	
}

###############################################################################

set w {}
wm title . "Tkabber"
wm iconname . "Tkabber"
wm group . .

set toolbaricon(groupchat) [Bitmap::get [pixmap tkabber glade-groupchat.gif]]
set toolbaricon(newuser)   [Bitmap::get [pixmap tkabber glade-new-user.gif]]
set toolbaricon(jb)        [Bitmap::get [pixmap tkabber jb.gif]]
set toolbaricon(online)    [Bitmap::get [pixmap tkabber glade-online.gif]]
set toolbaricon(offline)   [Bitmap::get [pixmap tkabber glade-offline.gif]]


set descmenu [list \
		  "&Tkabber" {} {} 1 \
		  [list \
		       [list cascad [::msgcat::mc "Presence"] {} presence 1 \
			    [list \
				 [list command [::msgcat::mc "Online"] {} {} {} \
				      -command {set userstatus available}] \
				 [list command [::msgcat::mc "Free to chat"] {} {} {} \
				      -command {set userstatus chat}] \
				 [list command [::msgcat::mc "Away"] {} {} {} \
				      -command {set userstatus away}] \
				 [list command [::msgcat::mc "Extended Away"] {} {} {} \
				      -command {set userstatus xa}] \
				 [list command [::msgcat::mc "Do not disturb"] {} {} {} \
				      -command {set userstatus dnd}] \
				 [list command [::msgcat::mc "Invisible"] {} {} {} \
				      -command {set userstatus invisible}]]] \
		       [list command [::msgcat::mc "Log in..."] {} {} {Ctrl l} \
			    -command {show_login_dialog}] \
		       [list command [::msgcat::mc "Log out"] {} {} {Ctrl j} \
			    -command {logout}] \
		       [list command [::msgcat::mc "Log out with reason..."] {} {} {} \
			    -command {show_logout_dialog}] \
		       {separator} \
		       [list command [::msgcat::mc "Profile on"] {} {} {} -command {
			   profile -commands -eval on
		       }] \
		       [list command [::msgcat::mc "Profile report"] {} {} {} -command {
			   profile off profil
			   profrep profil real profresults
		       }] \
		       {separator} \
		       [list command [::msgcat::mc "Quit"] {} {} {} \
			    -command {quit}] \
		      ] \
		  "&[::msgcat::mc Services]" {} {} 1 \
		  [list \
		       [list command [::msgcat::mc "Send message..."] {} {} {} \
			    -command {message::send_dialog}] \
		       [list cascad [::msgcat::mc "Roster"] {} {} 1 \
			    [list \
				 [list command [::msgcat::mc "Add user..."] {} {} {} \
				      -command message::send_subscribe_dialog] \
				 [list command [::msgcat::mc "Add conference..."] {} {} {} \
				      -command {add_group_dialog}]]] \
		       [list command [::msgcat::mc "Browser"] {} {} {} \
			    -command {browser::open}] \
		       [list command [::msgcat::mc "Discovery"] {} {} {} \
			    -command {disco::browser::open_win}] \
		       [list command [::msgcat::mc "Join group..."] {} {} {}\
			    -command {join_group_dialog}] \
		       [list cascad [::msgcat::mc "Chats"] {} {} 1 \
			    [list \
				 [list checkbutton \
				      [::msgcat::mc \
					   "Generate event messages"] \
				      {} {} {} \
				      -variable muc::options(gen_events)] \
				 [list checkbutton [::msgcat::mc "Stop autoscroll"] {} {} {} \
				      -variable chat::options(stop_scroll)]]] \
		       [list command [::msgcat::mc "Filters..."] {} {} {} \
			    -command {filters::open}] \
		       [list command [::msgcat::mc "Change password..."] {} {} {} \
			    -command {change_password_dialog}] \
		       [list command [::msgcat::mc "Edit my info..."] {} {} {} \
			    -command {userinfo::open ${loginconf(user)}@$loginconf(server)/$loginconf(resource) 1}] \
		       [list cascad [::msgcat::mc "Avatar"] {} {} 1 \
			    [list \
				 [list checkbutton [::msgcat::mc "Announce"] {} {} {} \
				      -variable avatar::options(announce)] \
				 [list checkbutton [::msgcat::mc "Allow downloading"] {} {} {} \
				      -variable avatar::options(share)] \
				 [list command [::msgcat::mc "Send to server"] {} {} {} \
				      -command {avatar::store_on_server}]]] \
		       [list cascad [::msgcat::mc "Jidlink"] \
			    {} jidlink 1 {}] \
		       {separator} \
		       [list cascad [::msgcat::mc "Admin tools"] {} {} 1 \
			    [list \
				 [list command [::msgcat::mc "Send broadcast message..."] {} {} {} \
				-command {eval {message::send_dialog \
						    "$loginconf(server)/announce/online" \
						}}] \
				 [list command [::msgcat::mc "Send message of the day..."] {} {} {} \
				-command {eval {message::send_dialog \
						    "$loginconf(server)/announce/motd" \
						}}] \
				 [list command [::msgcat::mc "Update message of the day..."] {} {} {} \
				-command {eval {message::send_dialog \
						    "$loginconf(server)/announce/motd/update" \
						}}] \
				 [list command [::msgcat::mc "Delete message of the day"] {} {} {} \
				-command {eval {message::send_msg \
						    "$loginconf(server)/announce/motd/delete" -type normal \
						}}] \
				 [list command [::msgcat::mc "Send raw XML..."] {} {} {} \
				      -command show_rawxml_dialog]]]] \
		  "&[::msgcat::mc Help]" {} {} 1 \
		  [list \
		       [list command [::msgcat::mc "Quick help..."] {} {} {} \
			    -command {
				help_window [::msgcat::mc "Quick Help"] \
				    "\n[::msgcat::mc {Main window:}]
    Ctrl-L		[::msgcat::mc {Log in}]
    Ctrl-J		[::msgcat::mc {Log out}]
\n[::msgcat::mc Tabs:]
    Ctrl-F4		[::msgcat::mc {Close tab}]
    Ctrl-PgUp/Down	[::msgcat::mc {Previous/Next tab}]
    Alt-\[0-9\]     	[::msgcat::mc {Switch to tab number 10,1-9}]
    Ctrl-R		[::msgcat::mc {Hide/Show roster}]
\n[::msgcat::mc Chats:]
    TAB		[::msgcat::mc {Complete nickname}]
    Ctrl-Up/Down	[::msgcat::mc {Previous/Next history message}]
    Alt-E		[::msgcat::mc {Show emoticons}]
    Ctrl-Z		[::msgcat::mc {Undo}]
    Ctrl-Shift-Z	[::msgcat::mc {Redo}]
    Alt-PgUp/Down	[::msgcat::mc {Scroll chat window up/down}]
    Right mouse	[::msgcat::mc {Correct word}]
"
			    }] \
		       [list command [::msgcat::mc "About..."] {} {} {} \
			    -command about_window] \
		      ] \
		 ]



if {[clength [info commands profile]] == 0} {
    set tmpmenu {}
    set eatP 0
    foreach menu [lindex $descmenu 4] {
        if {[::msgcat::mc "Profile on"] == [lindex $menu 1] || \
		[::msgcat::mc "Profile report"] == [lindex $menu 1]} {
	    set eatP 1
	} elseif {$eatP} {
	    set eatP 0
	} else {
            lappend tmpmenu $menu
        }
    }
    set descmenu [lreplace $descmenu 4 4 $tmpmenu]
}

proc about_window {} {
    global version
    help_window [::msgcat::mc "About"] "
Tkabber $version

Copyright (c) 2002 [::msgcat::mc {Alexey Shchepin}]
\n[::msgcat::mc Authors:]
    [::msgcat::mc {Alexey Shchepin}]
    [::msgcat::mc {Marshall T. Rose}]
    [::msgcat::mc {Sergei Golovan}]
    [::msgcat::mc {Michail Litvak}]

http://www.jabber.ru/projects/tkabber/"
}

proc help_window {title message} {
    set mainlogo info

    catch { MessageDlg .oops -type unknown }
    if {[lsearch -exact [set enum [lindex $::Widget::MessageDlg::opt(-icon) \
					  3]] \
			[set mainlogo [pixmap tkabber mainlogo.gif]]] < 0} {
	Bitmap::get $mainlogo
	lappend enum $mainlogo
	set ::Widget::MessageDlg::opt(-icon) \
	    [lreplace $::Widget::MessageDlg::opt(-icon) 3 3 $enum]
    }

    MessageDlg .m -anchor center -aspect 50000 -title $title -icon $mainlogo \
	-type user -buttons [::msgcat::mc "OK"] -default 0 -message $message
}

proc help_window {title message} {
    
    set mainlogo [Bitmap::get [pixmap tkabber mainlogo.gif]]
    Dialog .m -anchor e -separator yes -title $title -image $mainlogo \
	    -side bottom -modal local -cancel 0
    .m add -text [::msgcat::mc "OK"]
    set frame [.m getframe]
    message $frame.msg -text $message
    pack $frame.msg -side left
    .m setfocus 0
    .m draw
    destroy .m
}

set descmenu [menuload $descmenu]

set mf [MainFrame .mainframe -menu $descmenu -textvariable status]
pack $mf -expand yes -fill both
unset descmenu

bind $mf <Destroy> {
    jlib::disconnect
    quit
}

set bbox [ButtonBox [$mf addtoolbar].bbox -spacing 0 -padx 1 -pady 1]

$bbox add -image $toolbaricon(newuser) \
    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
    -padx 1 -pady 1 -command message::send_subscribe_dialog \
    -helptext [::msgcat::mc "Add new user..."]
$bbox add -image $toolbaricon(jb) \
    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
    -padx 1 -pady 1 -command {browser::open} \
    -helptext [::msgcat::mc "Jabber Browser"]
$bbox add -image $toolbaricon(groupchat) \
    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
    -padx 1 -pady 1 -command {join_group_dialog} \
    -helptext [::msgcat::mc "Join group..."]
if {$roster::show_only_online} {
    set button_image $toolbaricon(offline)
    set button_helptext [::msgcat::mc "Show online & offline users"]
} else {
    set button_image $toolbaricon(online)
    set button_helptext [::msgcat::mc "Show online users only"]
}
$bbox add -image $button_image \
    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
    -padx 1 -pady 1 -command {roster::switch_only_online} \
    -helptext $button_helptext
unset button_image button_helptext
if {![cequal [info commands ::ssj::sign:toggleP] ""]} {
    set b $bbox.b[llength [winfo children $bbox]]
    $bbox add -image [message::signed:icon]			\
	-highlightthickness 0 -takefocus 0 -relief link		\
	-borderwidth 1 -padx 1 -pady 1 -helptype balloon	\
	-helptext [::msgcat::mc "Toggle signing"]		\
	-command ssj::sign:toggleP
    ssj::signed:trace "$b configure -image \[message::signed:icon\]"
    unset b
}
if {![cequal [info commands ::ssj::encrypt:toggleP] ""]} {
    set b $bbox.b[llength [winfo children $bbox]]
    $bbox add -image [message::encrypted:icon]				\
	-highlightthickness 0 -takefocus 0 -relief link			\
	-borderwidth 1 -padx 1 -pady 1 -helptype balloon		\
	-helptext [::msgcat::mc "Toggle encryption (when possible)"]    \
	-command ssj::encrypt:toggleP
    ssj::encrypted:trace "$b configure -image \[message::encrypted:icon\]"
    unset b
}
pack $bbox -side left -anchor w


set ww 0
foreach str [list [::msgcat::mc "Online"] \
	[::msgcat::mc "Free to chat"] \
	[::msgcat::mc "Away"] \
	[::msgcat::mc "Extended Away"] \
	[::msgcat::mc "Do not disturb"] \
	[::msgcat::mc "Invisible"] \
	[::msgcat::mc "Not logged in"]] {
    if {[string length $str] > $ww} {
	set ww [string length $str]
    }
}

frame .presence
menubutton .presence.button -menu .presence.button.menu -relief raised \
    -textvariable userstatusdesc -direction above -width $ww
unset str ww
bind [entry .presence.status -textvariable textstatus \
	    		     -relief ridge] \
        <Return> {set userstatus $userstatus}
if {$usetabbar} {
    # pack .presence.button -side left -padx 2m
    pack .presence.button -side left
    pack .presence.status -side left -fill x -expand yes
} else {
    # pack .presence.button -side top -padx 2m -anchor w
    pack .presence.button -side top -anchor w
    pack .presence.status -side top -fill x -expand yes -anchor w
}
pack .presence -side bottom -anchor w -in [$mf getframe] -fill x

if {[winfo exists [set m $w.presence.button.menu]]} {
    destroy $m
}
menu $m
$m add command -label [::msgcat::mc "Online"] \
    -command {set userstatus available}
$m add command -label [::msgcat::mc "Free to chat"] \
    -command {set userstatus chat}
$m add command -label [::msgcat::mc "Away"] \
    -command {set userstatus away}
$m add command -label [::msgcat::mc "Extended Away"] \
    -command {set userstatus xa}
$m add command -label [::msgcat::mc "Do not disturb"] \
    -command {set userstatus dnd}
$m add command -label [::msgcat::mc "Invisible"] \
    -command {set userstatus invisible}

set rosterwidth [option get . mainRosterWidth [winfo class .]]
if {$rosterwidth == ""} {
    set rosterwidth [winfo pixels . 4c]
}

if {$usetabbar} {
    set pw [PanedWindow [$mf getframe].pw -side bottom]
    pack $pw -fill both -expand yes
    set rw [$pw add -minsize 0 -weight 0]
    set nw [$pw add -minsize 32 -weight 1]

    roster::create $w.roster -width $rosterwidth -height 300 \
	-popup roster::popup_menu
    pack $w.roster -expand yes -fill both -side left -in $rw

    NoteBook .nb -width 400
    pack .nb -side right -in $nw -fill both -expand yes
    [winfo parent $rw] configure -width $rosterwidth

    bind . <Control-Key-r> {collapse_roster}
    bind . <Control-Prior> {tab_move .nb -1}
    bind . <Control-Next> {tab_move .nb 1}
    bind . <Control-Key-F4> {
	if {[.nb raise] != ""} {
	    eval destroy [pack slaves [.nb getframe [.nb raise]]]
	    .nb delete [.nb raise] 1
	    tab_move .nb 0
	}
    }

    for {set i 1} {$i < 10} {incr i} {
	bind . <Meta-Key-$i> [list tab_raise_by_number .nb $i]
	bind . <Alt-Key-$i> [list tab_raise_by_number .nb $i]
    }
    unset i
    bind . <Meta-Key-0> [list tab_raise_by_number .nb 10]
    bind . <Alt-Key-0> [list tab_raise_by_number .nb 10]

    set m [menu .tabsmenu -tearoff 0]
    $m add command -label [::msgcat::mc "Close"] -accelerator Ctrl-F4 \
	-command {
	    if {[.nb raise] != ""} {
		eval destroy [pack slaves [.nb getframe $curmenutab]]
		.nb delete $curmenutab 1
		tab_move .nb 0
	    }
	}
    $m add command -label [::msgcat::mc "Close other tabs"] \
	-command {
	    foreach tab [.nb pages] {
		if {$tab != $curmenutab} {
		    eval destroy [pack slaves [.nb getframe $tab]]
		    .nb delete $tab 1
		}
	    }
	    tab_move .nb 0
	}
    $m add command -label [::msgcat::mc "Close all tabs"] \
	-command {
	    foreach tab [.nb pages] {
		eval destroy [pack slaves [.nb getframe $tab]]
		.nb delete $tab 1
	    }
	}

    .nb bindtabs <3> {tab_menu %X %Y}

    set geometry [option get . geometry [winfo class .]]
    if {$geometry == ""} {
	set geometry 788x550+0+0
    }

    unset pw m
} else {
    roster::create $w.roster -width $rosterwidth -height 300 \
	-popup roster::popup_menu
    pack $w.roster -expand yes -fill both -side left -in [$mf getframe]
    set geometry [option get . geometry [winfo class .]]
    if {$geometry == ""} {
	set geometry 200x350+0+0
    }
}

wm geometry . $geometry

unset mf

if {$usetabbar} {
    bind . <FocusIn> [list ::get_focus .]
    bind . <FocusOut> [list ::lose_focus .]
}

proc add_win {path args} {
    global usetabbar raise_new_tab

    set title ""
    set tabtitle ""
    set class ""
    set raisecmd ""

    foreach {attr val} $args {
	switch -- $attr {
	    -title    {set title    $val}
	    -tabtitle {set tabtitle $val}
	    -class    {set class    $val}
	    -raisecmd {set raisecmd $val}
	    default {error "Unknown option $attr"}
	}
    }

    if {$usetabbar} {
	set page [crange [win_id tab $path] 1 end]
	set f [.nb insert end $page -text $tabtitle -raisecmd $raisecmd]
	frame $path -class $class
	pack $path -expand yes -fill both -in $f
	#tkwait visibility $path
	set ::tabcolors($page) ""
	if {$raise_new_tab || [llength [.nb pages]] == 1} {
	    after idle [list catch [list .nb raise $page]]
	}
    } else {
	toplevel $path -class $class -relief flat -bd 2m
	wm title $path $title
	wm iconname $path $title
	set geometry [option get $path geometry $class]
	if {$geometry != ""} {
	    wm geometry $path $geometry
	}
	bind $path <FocusIn> [list ::get_focus $path]
	bind $path <FocusOut> [list ::lose_focus $path]
    }
}

set focused {}
set after_focused_id {}
set after_focused_delay 600

proc get_focus {path} {
    global focused after_focused_id after_focused_delay usetabbar

    if {![winfo exists $path]} return
    if {[winfo toplevel $path] != $path} return

    if {$usetabbar} {
	if {[set p [.nb raise]] != ""} {
	    tab_set_updated $p
	}
    }

    if {$focused != $path} {
	if {$after_focused_id != {}} {
	    after cancel $after_focused_id
	}
	regsub {^\(\d+\*?\) } [wm title $path] {} title
	set after_focused_id [after $after_focused_delay [list ::set_title $path $title]]
	set focused $path
    }
}

proc set_title {path title} {
    if {![winfo exists $path]} return
    wm title $path $title
}

proc lose_focus {path} {
    global focused after_focused_id

    if {![winfo exists $path]} return
    if {[winfo toplevel $path] != $path} return

    if {($focused == $path) && ($after_focused_id != {})} {
	after cancel $after_focused_id
	set after_focused_id {}
    }
    set focused {}
}

proc add_number_of_messages_to_title {jid from type body extras} {
    global usetabbar
    global focused

    set w [winfo toplevel [chat::chat_win $jid]]
    if {$w == $focused} return

    set title [wm title $w]
    if {[regexp {^\((\d+)\*?\) } $title fake num_messages]} {
	incr num_messages
    } else {
	set num_messages 1
    }
    set star ""
    if {$type == "chat"} {
	set star "*"
    } elseif {$type == "groupchat"} {
	set myjid [chat::our_jid $jid]
	set mynick [chat::get_nick $myjid $type]
	if {[crange $body 0 [expr [clength $mynick] + 1]] == "${mynick}: "} {
	    set star "*"
	}
    }
    regsub {(^\(\d+\*?\) )?} $title "($num_messages$star) " title
    wm title $w $title
}

hook::add draw_message_hook ::add_number_of_messages_to_title 18

set checkfocusP 1
proc tab_move {nb shift} {
    global checkfocusP

    set checkfocusP 0
    set len [llength [$nb pages]]

    if {$len > 0} {
	set newidx [expr [$nb index [$nb raise]] + $shift]

	if {$newidx < 0} {
	    set newidx [expr $len - 1]
	} elseif {$newidx >= $len} {
	    set newidx 0
	}

	$nb see [lindex [$nb pages] $newidx]
	$nb raise [lindex [$nb pages] $newidx]
    }
}

proc tab_raise_by_number {nb num} {
    set pages [$nb pages]
    incr num -1
    set page [lindex $pages $num]
    if {$page != ""} {
	$nb raise $page
    }
}

if {$usetabbar} {
    array set alert_lvls {error 1 server 1 message 2 mesg_to_user 3}

    option add *NoteBook.alertColor0 Black widgetDefault
    option add *NoteBook.alertColor1 DarkBlue widgetDefault
    option add *NoteBook.alertColor2 Blue widgetDefault
    option add *NoteBook.alertColor3 Red widgetDefault

    set alert_colors [list \
			  [option get .nb alertColor0 NoteBook] \
			  [option get .nb alertColor1 NoteBook] \
			  [option get .nb alertColor2 NoteBook] \
			  [option get .nb alertColor3 NoteBook]]
}

proc tab_set_updated {path {updated 0} {level ""}} {
    global usetabbar
    global tabcolors
    global alert_lvls alert_colors
    global focused
    global checkfocusP

    if {$usetabbar} {
	set page [crange [win_id tab $path] 1 end]
	if {[.nb index $page] < 0} {
	    set page $path
	}

	set st [wm state .]
	if {![cequal $st normal] && ![cequal $st zoomed]} {
	    set backgroundP 1
	} else {
	    set backgroundP 0
	}
	if {$checkfocusP} {
	    if {[cequal $focused ""]} {
		set backgroundP 1
	    }
	} else {
	    set checkfocusP 1
	}
        if {!$updated && $backgroundP} {
	    set updated 1
	    set level message
	}

	if {$updated \
		&& (($page != [.nb raise]) \
			&& ([info exists alert_lvls($level)])
		    || $backgroundP)} {
	    set lvlnum $alert_lvls($level)
	} else {
	    set lvlnum 0
	}

	if {!$updated || $tabcolors($page) < $lvlnum} {
	    set color [lindex $alert_colors $lvlnum]
	    .nb itemconfigure $page -foreground $color
	    set tabcolors($page) $lvlnum
	}

	#debugmsg iface "$path $updated $page $tabcolors($page) [.nb raise]"
    }
}

proc tab_menu {x y page} {
    global curmenutab
    set curmenutab $page
    tk_popup .tabsmenu $x $y    
}

###############################################################################

proc collapse_roster {} {
    global rw nw
    set r [[winfo parent $rw] cget -width]
    set n [[winfo parent $nw] cget -width]
    [winfo parent $rw] configure -width 0
    [winfo parent $nw] configure -width [expr {$r + $n}]
    bind . <Control-Key-r> {uncollapse_roster}
}

proc uncollapse_roster {} {
    global rw nw
    set w [winfo pixels . 4c]
    set r [[winfo parent $rw] cget -width]
    set n [[winfo parent $nw] cget -width]
    [winfo parent $rw] configure -width $w
    [winfo parent $nw] configure -width [expr {$r + $n - $w}]
    bind . <Control-Key-r> {collapse_roster}
}


###############################################################################

set status_afterid ""

proc set_status {text} {
    global status
    global status_afterid

    after cancel $status_afterid
    set status $text
    set status_afterid [after 5000 clear_status]
}

proc clear_status {} {
    global status

    set status ""
}

###############################################################################

proc show_rawxml_dialog {} {
    global font

    set w .raw_xml_input

    if {[winfo exists $w]} {
	destroy $w
    }

    toplevel $w
    wm title $w [::msgcat::mc "Raw XML input"]
    
    set bbox [ButtonBox $w.bbox -spacing 10 -padx 10]
    $bbox add -text [::msgcat::mc "Send"] -command "
	jlib::outmsg \[$w.frame.t get 0.0 end\]
	destroy $w
    "
    $bbox add -text [::msgcat::mc "Cancel"] -command [list destroy $w]
    bind $w <Control-Return> "ButtonBox::invoke $bbox 0"
    bind $w <Escape> "ButtonBox::invoke $bbox 1"
    pack $bbox -side bottom -anchor e -padx 2m -pady 2m

    set sep [Separator::create $w.sep -orient horizontal]
    pack $sep -pady 1m -fill x -side bottom

    frame $w.frame
    text $w.frame.t -font $font
    pack $w.frame.t -fill both -expand yes
    pack $w.frame -fill both -expand yes -padx 2m -pady 2m
    bind $w.frame.t <Control-Return> "
	ButtonBox::invoke $bbox 0                
        break"                                                              

    focus $w.frame.t
}


