# $Id: autoaway.tcl,v 1.1 2002/11/02 20:42:02 alexey Exp $

namespace eval autoaway {
    variable options

    array set options [list awaytime [expr  5*60*1000] \
			    xatime   [expr 15*60*1000]]

    variable savestatus ""
    variable savetext   "" 
}


proc autoaway::load {} {
    if {[catch { package require tkXwin }]} {
	return
    }

    hook::add connected_hook    [namespace current]::after_idle
    hook::add disconnected_hook [namespace current]::after_idle_cancel
}


proc autoaway::after_idle {} {
    after_idle_aux
    after 100 [namespace current]::after_idle
}

proc autoaway::after_idle_cancel {} {
    after cancel [namespace current]::after_idle
}

proc autoaway::after_idle_aux {} {
    variable options
    variable savestatus
    variable savetext
    global   userstatus textstatus

    if {($options(awaytime) <= 0) && ($options(xatime) <= 0)} {
        return
    }

    if {[set idletime [tkXwin::idletime]] < $options(awaytime)} {
        if {![cequal $savestatus ""]} {
	    set textstatus $savetext
	    set savetext ""
            set userstatus $savestatus
            set savestatus ""
            set_status [::msgcat::mc "Returning from auto-away"]
        }

        return
    }

    switch -- $userstatus {
        available
            -
        chat {
            set savestatus $userstatus
	    set savetext $textstatus
            set textstatus [::msgcat::mc "Automatically away due to idle"]
            if {$idletime >= $options(xatime)} {
                set userstatus xa
                set_status [::msgcat::mc "Moving to extended away"]
            } else {
                set userstatus away
                set_status [::msgcat::mc "Starting auto-away"]
            }
	    update
	    set ::sound::options(mute) 1
            return
        }

        away {
            if {(![cequal $savestatus ""]) \
		    && ($idletime >= $options(xatime))} {
                set textstatus [::msgcat::mc "Automatically away due to idle"]
                set userstatus xa
                set_status [::msgcat::mc "Moving to extended away"]
		update
		set ::sound::options(mute) 1
                return
            }
        }

        default {
        }
    }

    if {![cequal $savestatus ""]} {
        set_status [format [::msgcat::mc "Idle for %s"] [userinfo::make_message [expr $idletime/1000]]]
    }
}


autoaway::load
